<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: delivery.php 3496 2005-08-02 14:50:13Z andrew $
*/

require_once MAX_PATH . '/lib/max/Delivery.php';
require_once MAX_PATH . '/lib/max/SqlBuilder.php';

function MAX_selectAd1($what, $target = '', $source = '', $withText = 0, $aContext = 0, $richMedia = true, $ct0 ='')
{
    if (substr($what,0,5) == 'zone:') {
        $aCheckedChains = array();
        $chain = $what;
        while (true) {
            $aAd = null;
            $aCheckedChains[] = $chain;
            $zoneId  = intval(substr($chain,5));
            $aZone = MAX_getZoneLinkedAds($zoneId, true, true);
            $aAd = _selectAd($aZone['ads'], $aContext, $richMedia);
            if (!empty($aAd)) {
                $aAd['html'] = MAX_buildAdHtml($aAd, $zoneId, $source, $target, $ct0, $withText, true, true, $richMedia);
                break;
            } elseif (!empty($aZone['chain']) && !in_array($aZone['chain'], $aCheckedChains)) {
                $chain = $aZone['chain'];
            } else {
                break;
            }
        }
    } else {
        $aSearch = array();
        $aTmpSearch = explode(',', $what);
        foreach ($aTmpSearch as $tmpSearch) {
            if (strpos($tmpSearch, '/') !== false) {
                $aPieces = explode('/', $tmpSearch);
                while (!empty($aPieces)) {
                    $aSearch[] = implode('&', $aPieces);
                    unset($aPieces[sizeof($aPieces)-1]);
                }
            } else {
                $aSearch[] = $tmpSearch;
            }
        }
        foreach ($aSearch as $search) {
            $aAds = MAX_getLinkedAds($search, true, true);
            $aAd = _selectAd($aAds, $aContext, $richMedia);
            if (!empty($aAd)) {
                $aAd['html'] = MAX_buildAdHtml($aAd, 0, $source, $target, $ct0, $withText, true, true, $richMedia);
                break;
            }
        }
    }
    return $aAd;
}

function MAX_getZoneLinkedAds($zoneId, $allFields, $cached = false, $timeout = -1)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($cached) {
        include_once 'Cache/Lite/Function.php';
        $options = array('cacheDir' => MAX_CACHE, 'lifeTime' => ($timeout > -1 ? $timeout : $conf['delivery']['cacheExpire']));
        $cache = new Cache_Lite_Function($options);
        $aRows = $cache->call('MAX_getZoneLinkedAds', $zoneId, $allFields);
    } else {
        if (isset($conf['origin']['type']) && is_readable(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php')) {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php');
        } else {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['database']['type']) . '.php');
        }
        $aRows  = MAX_Dal_Delivery_getZoneLinkedAds($zoneId);
    }
    return $aRows;
}

function MAX_getZoneInfo($zoneId, $cached = false, $timeout = -1)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($cached) {
        include_once 'Cache/Lite/Function.php';
        $options = array('cacheDir' => MAX_CACHE, 'lifeTime' => ($timeout > -1 ? $timeout : $conf['delivery']['cacheExpire']));
        $cache = new Cache_Lite_Function($options);
        $aRows = $cache->call('MAX_getZoneInfo', $zoneId);
    } else {
        if (isset($conf['origin']['type']) && is_readable(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php')) {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php');
        } else {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['database']['type']) . '.php');
        }
        $aRows  = MAX_Dal_Delivery_getZoneInfo($zoneId);
    }
    return $aRows;
}

function MAX_getAd($ad_id, $cached = false, $timeout = -1)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($cached) {
        include_once 'Cache/Lite/Function.php';
        $options = array('cacheDir' => MAX_CACHE, 'lifeTime' => ($timeout > -1 ? $timeout : $conf['delivery']['cacheExpire']));
        $cache = new Cache_Lite_Function($options);
        $aRows = $cache->call('MAX_getAd', $ad_id);
    } else {
        if (isset($conf['origin']['type']) && is_readable(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php')) {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php');
        } else {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['database']['type']) . '.php');
        }
        $aRows  = MAX_Dal_Delivery_getAd($ad_id);
    }
    return $aRows;
}

function _sortArrayPriority($a, $b)
{
    $compare = ($a['priority'] > $b['priority']) ? -1 : 1;
    return $compare;
}
/*
(kw1&kw2)|(k3|bannerid:123) = kw1 AND kw2
kw1|kw2 = kw1 OR kw2
-kw1 = NOT kw1

bannerid:123 = bannerid=123
width:468    = width=468
height:60    = height=60
cat:kw1      = keyword=kw1
*/
function MAX_getLinkedAds($search, $allFields, $cached = false, $timeout = -1)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($cached) {
        include_once 'Cache/Lite/Function.php';
        $options = array('cacheDir' => MAX_CACHE, 'lifeTime' => ($timeout > -1 ? $timeout : $conf['delivery']['cacheExpire']));
        $cache = new Cache_Lite_Function($options);
        $aAds = $cache->call('MAX_getLinkedAds', $search, $allFields);
    } else {
        if (isset($conf['origin']['type']) && is_readable(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php')) {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['origin']['type']) . '.php');
        } else {
            require_once(MAX_PATH . '/lib/max/Dal/Delivery/' . strtolower($conf['database']['type']) . '.php');
        }
        $aAds = MAX_Dal_Delivery_getLinkedAds($search);
    }
    return $aAds;
}

function _selectAd($aAds, $aContext, $richMedia)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $aSelectedAd = null;
    if (!empty($aAds)) {
        if (!empty($aContext)) {
            $aAdInclude = array();
            $aAdExclude = array();
            $aPlacementInclude = array();
            $aPlacementExclude = array();
            foreach($aContext as $key => $value) {
                $aContextValues = explode(':', $value);
                if (count($aContextValues) == 1) {
                    $type = 'bannerid';
                } else {
                    list($type, $value) = $aContextValues;
                }
                if ($type == 'bannerid') {
                    if ($key == '!=') {
                        $excludeAdID[$value] = true;
                    } else {
                        $includeAdID[$value] = true;
                    }
                } elseif ($type == 'campaignid') {
                    if ($key == '!=') {
                        $excludePlacementID[$value] = true;
                    } else {
                        $includePlacementID[$value] = true;
                    }
                }
            }
        }
        $total = 0;
        foreach ($aAds as $adId => $aAd) {
            $valid = true;
            if (!empty($aContext)) {
                // Excludelist ads
                if (isset($excludeAdID[$rows[$i]['bannerid']])) {
                    $valid = false;
                    // Excludelist placements
                } elseif (isset($excludePlacementID[$rows[$i]['campaignid']])) {
                    $valid = false;
                    // Includelist ads
                } elseif (sizeof($includeAdID) && !isset ($includeAdID[$rows[$i]['bannerid']])) {
                    $valid = false;
                    // Includelist placements
                } elseif (sizeof($includePlacementID) && !isset ($includePlacementID[$rows[$i]['campaignid']])) {
                    $valid = false;
                }
            }
            if ($valid) {
                // Test for Rich Media...
                if ($richMedia == false && !($aAd['contenttype'] == 'jpeg' || $aAd['contenttype'] == 'gif' || $aAd['contenttype'] == 'png') && !($aAd['type'] == 'url' && $aAd['contenttype'] == '')) {
                    $valid = false;
                    // Is the ad blocked
                } elseif (phpAds_isAdBlocked($adId, $aAd['block'])) {
                    $valid = false;
                    // Is the ad capped
                } elseif (phpAds_isAdCapped($adId, $aAd['capping'], $aAd['session_capping'])) {
                    $valid = false;
                    // HTML Ads that contain 'http:' on SSL
                } elseif ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort'] && $aAd['type'] == 'html' && strpos($aAd['htmlcache'], 'http:') !== false) {
                    $valid = false;
                    // External Ads that contain 'http:' on SSL
                } elseif ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort'] && $aAd['type'] == 'url' && strpos($aAd['url'], 'http:') !== false) {
                    $valid = false;
                    // Limitations
                } elseif (!empty($aAd['compiledlimitation'])) {
                    include_once MAX_PATH . '/lib/max/other/lib-limitations.inc.php';
                    $valid = phpAds_aclCheck($aAd, $source);
                }
            }

            if (!$valid) {
                unset($aAds[$adId]);
            } else {
                $total += $aAd['priority'];
            }
        }

        if (!empty($aAds)) {
            $random = mt_rand(0, $total - 1);
            $sum = 0;
            //Check to see which ad should be served
            foreach ($aAds as $aAd) {
                $sum += $aAd['priority'];
                if ($random < $sum) {
                    $aSelectedAd = $aAd;
                    break;
                }
            }
        }
    }

    return $aSelectedAd;
}

function view($what, $target = '', $source = '', $withtext = 0, $context = 0, $richmedia = true)
{
    $output = view_raw($what, "$target", "$source", $withtext, $context, $richmedia);
    print($output['html']);
    return ($output['ad_id']);
}

function MAX_buildAdHtml($aAd, $zoneId=0, $source='', $target='', $ct0='', $withText=false, $logClick=true, $logView=true, $richMedia=true)
{
    $conf = $GLOBALS['_MAX']['PREF'];
    $code = '';
    switch ($aAd['contenttype']) {
        case 'gif'  :
        case 'jpeg' :
        case 'png'  :
        $code = _buildAdCodeImage($aAd, $zoneId, $source, $ct0, $withText, $logClick, $logView, false, $richMedia);
        break;
        case 'swf'  :
        $code = _buildAdCodeFlash($aAd, $zoneId, $source, $ct0, $withText, $logClick, $logView);
        break;
        case 'txt'  :
        $code = _buildAdCodeText($aAd, $zoneId, $source, $ct0, $withText, $logClick, $logView);
        break;
        case 'mov'  :
        $code = _buildAdCodeQuicktime($aAd, $zoneId, $source, $ct0, $withText, $logClick, $logView);
        break;
        default :
        switch ($aAd['type']) {
            case 'html' :
            $code = _buildAdCodeHtml($aAd, $zoneId, $source, $ct0, $withText, $logClick, $logView);
            break;
            case 'url' : // External ad without a recognised content type - assume image...
            $code = _buildAdCodeImage($aAd, $zoneId, $source, $ct0, $withText, $logClick, $logView, false, $richMedia);
            break;
            case 'txt' :
            $code = _buildAdCodeText($aAd, $zoneId, $source, $ct0, $withText, $logClick, $logView);
        }
        break;
    }
    // Transform any code
    // Get the target
    if (empty($target))
    $target = !empty($aAd['target']) ? $aAd['target'] : '_blank';
    // Get a timestamp
    list($usec, $sec) = explode(' ', microtime());
    $time = (float)$usec + (float)$sec;
    // Get a random number
    $random = substr(md5(uniqid($time, true)), 0, 10);
    // Get the click URL
    global $cookie_random;  // Temporary fix to get doubleclick tracking working (Bug # 88)
    $cookie_random = $random;
    $clickUrl = _buildClickUrl($aAd, $zoneId, $source, $ct0, $logClick, true);
    $urlPrefix = _getDeliveryUrl($conf['file']['click']);
    $code = str_replace('{clickurl}', urlencode($clickUrl), $code);  // This step needs to be done separately because {clickurl} can contain {random}...
    $search = array('{timestamp}','{random}','{target}','{url_prefix}','{bannerid}','{zoneid}','{source}');
    $replace = array($time, $random, $target, $urlPrefix, $aAd['ad_id'], $zoneId, $source);
    if ( ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort']) && ($aAd['autohtml'] == 't') && ($aAd['adserver'] != '') ) {
        $search[] = 'http:';
        $replace[] = 'https:';
    }
    $code = str_replace($search, $replace, $code);
    return $code;
}

function _buildAdCodeImage($aAd, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $useAlt=false, $richMedia=true)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if (!$richMedia) {
        return _buildFileUrl($aAd, $useAlt, '{random}');
    }
    $prepend = !empty($aAd['prepend']) ? $aAd['prepend'] : '';
    $append = !empty($aAd['append']) ? $aAd['append'] : '';
    // Create the anchor tag..
    $clickUrl = _buildClickUrl($aAd, $zoneId, $source, $ct0, $logClick);
    if (!empty($clickUrl)) {
        // There is a link
        $status = !empty($aAd['status']) ? " onMouseOver=\"self.status='{$aAd['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aAd['target']) ? $aAd['target'] : '_blank';
        $clickTag = "<a href='$clickUrl' target='$target'$status>";
        $clickTagEnd = '</a>';
    } else {
        $clickTag = '';
        $clickTagEnd = '';
    }
    // Create the image tag..
    $imageUrl = _buildFileUrl($aAd, $useAlt);
    if (!empty($imageUrl)) {
        $imgStatus = empty($clickTag) ? $status : '';
        $width = !empty($aAd['width']) ? $aAd['width'] : 0;
        $height = !empty($aAd['height']) ? $aAd['height'] : 0;
        $alt = !empty($aAd['alt']) ? $aAd['alt'] : '';
        $imageTag = "$clickTag<img src='$imageUrl' width='$width' height='$height' alt='$alt' title='$alt' border='0'$imgStatus>$clickTagEnd";
    } else {
        $imageTag = '';
    }
    // Get the text below the ad
    $adText = $withText && !empty($aAd['bannertext']) ? "<br />$clickTag{$aAd['bannertext']}$clickTagEnd" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aAd, $zoneId, $source) : '';
    return $prepend . $imageTag . $adText . $beaconTag . $append;
}

function _buildAdCodeFlash($aAd, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aAd['prepend']) ? $aAd['prepend'] : '';
    $append = !empty($aAd['append']) ? $aAd['append'] : '';
    $width = !empty($aAd['width']) ? $aAd['width'] : 0;
    $height = !empty($aAd['height']) ? $aAd['height'] : 0;
    $pluginVersion = !empty($aAd['pluginversion']) ? $aAd['pluginversion'] : '4';
    // $imageUrlPrefix = ($_SERVER['SERVER_PORT'] == 443) ? $conf['type_web_ssl_url'] : $conf['type_web_url'];
    $fileName = !empty($aAd['filename']) ? $aAd['filename'] : '';
    $altImageAdCode = !empty($aAd['alt_filename']) ? _buildAdCodeImage($aAd, $zoneId, $source, $ct0, false, $logClick, false, true) : '';
    // Create the anchor tag..
    $clickUrl = _buildClickUrl($aAd, $zoneId, $source, $ct0, $logClick);
    if (!empty($clickUrl)) {
        // There is a link
        $status = !empty($aAd['status']) ? " onMouseOver=\"self.status='{$aAd['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aAd['target']) ? $aAd['target'] : '_blank';
        $swfParams = 'clickTAG=' . $clickUrl;
        $clickTag = "<a href='$clickUrl' target='$target'$status>";
        $clickTagEnd = '</a>';
    } else {
        $swfParams = '';
        $clickTag = '';
        $clickTagEnd = '';
    }
    $fileUrl = _buildFileUrl($aAd, false, $swfParams);
    $protocol = ($_SERVER['SERVER_PORT'] == 443) ? "https" : "http";
    $code = "
<SCRIPT LANGUAGE='JavaScript' type='text/javascript'>
<!--
var plugin = (navigator.mimeTypes && navigator.mimeTypes['application/x-shockwave-flash']) ? navigator.mimeTypes['application/x-shockwave-flash'].enabledPlugin : 0;
if ( plugin ) {
    plugin = parseInt(plugin.description.substring(plugin.description.indexOf('.')-1)) >= $pluginVersion;
}
else if (navigator.userAgent && navigator.userAgent.indexOf('MSIE')>=0 && (navigator.userAgent.indexOf('Windows 95')>=0 || navigator.userAgent.indexOf('Windows 98')>=0 || navigator.userAgent.indexOf('Windows NT')>=0)) {
    document.write('<SCRIPT LANGUAGE=\"VBScript\"> \\n');
    document.write('on error resume next \\n');
    document.write('plugin = ( IsObject(CreateObject(\"ShockwaveFlash.ShockwaveFlash.$pluginVersion\")))\\n');
    document.write('</SCRIPT\> \\n');
}
if ( plugin ) {
    document.write(\"<object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' codebase='$protocol://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=$pluginVersion,0,0,0' width='$width' height='$height'>\");
    document.write(\"<param name='movie' value='$fileUrl'>\");
    document.write(\"<param name='quality' value='high'>\");

    document.write(\"<embed src='$fileUrl' quality='high' width='$width' height='$height' type='application/x-shockwave-flash' pluginspage='$protocol://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash'></embed>\");
    document.write(\"</object>\");
} else if (!(navigator.appName && navigator.appName.indexOf(\"Netscape\")>=0 && navigator.appVersion.indexOf(\"2.\")>=0)){
    document.write(\"" .str_replace('"', '\"', $altImageAdCode). "\");
}
//-->
</SCRIPT>
<noembed>$altImageAdCode</noembed>
<noscript>$altImageAdCode</noscript>
<!--End of code-->";
    $adText = $withText && !empty($aAd['bannertext']) ? "<br />{$clickTag}{$aAd['bannertext']}{$clickTagEnd}" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aAd, $zoneId, $source) : '';
    return "{$prepend}{$code}{$adText}{$beaconTag}{$append}";
}

function _buildAdCodeQuicktime($aAd, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aAd['prepend']) ? $aAd['prepend'] : '';
    $append = !empty($aAd['append']) ? $aAd['append'] : '';
    $width = !empty($aAd['width']) ? $aAd['width'] : 0;
    $height = !empty($aAd['height']) ? $aAd['height'] : 0;
    $pluginVersion = !empty($aAd['pluginversion']) ? $aAd['pluginversion'] : '4';
    // $imageUrlPrefix = ($_SERVER['SERVER_PORT'] == 443) ? $conf['type_web_ssl_url'] : $conf['type_web_url'];
    $fileName = !empty($aAd['filename']) ? $aAd['filename'] : '';
    $altImageAdCode = _buildAdCodeImage($aAd, $zoneId, $source, $ct0, false, $logClick, false, true);
    // Create the anchor tag..
    $clickTag = _buildClickUrl($aAd, $source, $ct0, $logClick);
    if (!empty($clickTag)) {
        // There is a link
        $status = !empty($aAd['status']) ? " onMouseOver=\"self.status='{$aAd['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aAd['target']) ? $aAd['target'] : '_blank';
        $swfParams = 'clickTAG=' . $clickTag;
        $anchor = "<a href='$clickTag' target='$target'$status>";
        $anchorEnd = '</a>';
    } else {
        $swfParams = '';
        $anchor = '';
        $anchorEnd = '';
    }
    $clickTag = _buildClickUrl($aAd, $source, $ct0, $logClick);
    $fileUrl = _buildFileUrl($aAd, false, $swfParams);
    $code = "
<object classid='clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B' codebase='http://www.apple.com/qtactivex/qtplugin.cab' width='$width' height='$height'>
<param name='src' value='$fileUrl'>
<param name='controller' value='false'>
<param name='autoplay' value='true'>
<embed src='$fileUrl' controller='false' autoplay='true' width='$width' height='$height' pluginspace='http://www.apple.com/quicktime/download/'></embed>
<noembed>$altImageAdCode</noembed>
</object>";
    $adText = $withText && !empty($aAd['bannertext']) ? "<br />{$anchor}{$aAd['bannertext']}{$anchorEnd}" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aAd, $zoneId, $source) : '';
    return $prepend . $code . $adText . $beaconTag . $append;
}

function _buildAdCodeReal($aAd, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aAd['prepend']) ? $aAd['prepend'] : '';
    $append = !empty($aAd['append']) ? $aAd['append'] : '';
    $width = !empty($aAd['width']) ? $aAd['width'] : 0;
    $height = !empty($aAd['height']) ? $aAd['height'] : 0;
    $pluginVersion = !empty($aAd['pluginversion']) ? $aAd['pluginversion'] : '4';
    // $imageUrlPrefix = ($_SERVER['SERVER_PORT'] == 443) ? $conf['type_web_ssl_url'] : $conf['type_web_url'];
    $fileName = !empty($aAd['filename']) ? $aAd['filename'] : '';
    $altImageAdCode = _buildAdCodeImage($aAd, $zoneId, $source, $ct0, false, $logClick, false, true);
    // Create the anchor tag..
    $clickTag = _buildClickUrl($aAd, $source, $ct0, $logClick);
    if (!empty($clickTag)) {
        // There is a link
        $status = !empty($aAd['status']) ? " onMouseOver=\"self.status='{$aAd['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aAd['target']) ? $aAd['target'] : '_blank';
        $swfParams = 'clickTAG=' . $clickTag;
        $anchor = "<a href='$clickTag' target='$target'$status>";
        $anchorEnd = '</a>';
    } else {
        $swfParams = '';
        $anchor = '';
        $anchorEnd = '';
    }
    $clickTag = _buildClickUrl($aAd, $source, $ct0, $logClick);
    $fileUrl = _buildFileUrl($aAd, false, $swfParams);
    $code = "
<object classid='clsid:CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA' width='$width' height='$height'>
<param name='src' value='$fileUrl'>
<param name='controls' value='ImageWindow'>
<param name='autostart' value='true'>
<embed src='$fileUrl' controls='ImageWindow' autostart='true' width='$width' height='$height' type='audio/x-pn-realaudio-plugin'></embed>
<noembed>$altImageAdCode</noembed>
</object>";
    $adText = $withText && !empty($aAd['bannertext']) ? "<br />{$anchor}{$aAd['bannertext']}{$anchorEnd}" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aAd, $zoneId, $source) : '';
    return $prepend . $code . $adText . $beaconTag . $append;
}

function _buildAdCodeHtml($aAd, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $useAlt=false)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aAd['prepend']) ? $aAd['prepend'] : '';
    $append = !empty($aAd['append']) ? $aAd['append'] : '';
    $code = !empty($aAd['htmlcache']) ? $aAd['htmlcache'] : '';
    // Get the text below the ad
    $adText = !empty($aAd['bannertext']) ? "$clickTag{$aAd['bannertext']}$clickTagEnd" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aAd, $zoneId, $source) : '';
    return $prepend . $code . $adText . $beaconTag . $append;
}

function _buildAdCodeText($aAd, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $useAlt=false)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aAd['prepend']) ? $aAd['prepend'] : '';
    $append = !empty($aAd['append']) ? $aAd['append'] : '';
    // Create the anchor tag..
    $clickUrl = _buildClickUrl($aAd, $zoneId, $source, $ct0, $logClick);
    if (!empty($clickUrl)) {
        // There is a link
        $status = !empty($aAd['status']) ? " onMouseOver=\"self.status='{$aAd['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aAd['target']) ? $aAd['target'] : '_blank';
        $clickTag = "<a href='$clickUrl' target='$target'$status>";
        $clickTagEnd = '</a>';
    } else {
        $clickTag = '';
        $clickTagEnd = '';
    }
    // Get the text below the ad
    $adText = !empty($aAd['bannertext']) ? "$clickTag{$aAd['bannertext']}$clickTagEnd" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aAd, $zoneId, $source) : '';
    return $prepend . $adText . $beaconTag . $append;

}

function _buildFileUrl($aBanner, $useAlt=false, $params='')
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $fileUrl = '';
    if ($aBanner['type'] == 'url') {
        $fileUrl = $aBanner['imageurl'];
    } else {
        $fileName = $useAlt ? $aBanner['alt_filename'] : $aBanner['filename'];
        $params = !empty($params) ? $params : '';
        if (!empty($fileName)) {
            if ($aBanner['type'] == 'web') {
                $fileUrl = _getImageUrlPrefix() . "/$fileName";
                if (!empty($params))
                $fileUrl .= "?$params";
            } elseif ($aBanner['type'] == 'url') {
                $fileUrl = $aBanner['imageurl'];
            } elseif ($aBanner['type'] == 'sql') {
                $fileUrl = _getDeliveryUrl($conf['file']['image']) . "?filename=$fileName&contenttype={$aBanner['contenttype']}";
                if (!empty($params))
                $fileUrl .= "&$params";
            }
        }
    }
    return $fileUrl;
}

function _buildClickUrl($aBanner, $zoneId=0, $source='', $ct0='', $logClick=true, $overrideDest=false)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $clickUrl = '';
    if (!empty($aBanner['url']) || $overrideDest) {
        // There is a link
        $del = $conf['delivery']['ctDelimiter'];
        $delnum = strlen($del);
        $random = "{$del}cb={random}";
        $bannerId = !empty($aBanner['bannerid']) ? "{$del}bannerid={$aBanner['bannerid']}" : '';
        $source = !empty($source) ? "{$del}source=" . urlencode($source) : '';
        $log = $logClick ? '' : "{$del}log=no";
        // Determine the destination
        $dest = !empty($aBanner['url']) ? $aBanner['url'] : '';
        $ct0 = (empty($ct0) || $ct0 == 'Insert_Clicktrack_URL_Here') ? '' : $ct0;
        $aBanner['contenttype'] == "swf" ? $maxdest = '' : $maxdest = "{$del}maxdest={$ct0}{$dest}";
        $clickUrl = _getDeliveryUrl($conf['file']['click']) . "?maxparams={$delnum}{$bannerId}{$del}zoneid={$zoneId}{$source}{$log}{$random}{$maxdest}";
    }
    return $clickUrl;
}

function _buildImageBeacon($aBanner, $zoneId = 0, $source = '', $loc = '', $referer = '')
{
    $conf = $GLOBALS['_MAX']['CONF'];
    // Add beacon image for logging
    if (isset($_SERVER['HTTP_USER_AGENT']) && preg_match("#Mozilla/(1|2|3|4)#", $_SERVER['HTTP_USER_AGENT'])
        && !preg_match("#compatible#", $_SERVER['HTTP_USER_AGENT'])) {
        $div = "<layer id='beacon_{$aBanner['bannerid']}' width='0' height='0' border='0' visibility='hide'>";
        $style = '';
        $divEnd = '</layer>';
    } else {
        $div = "<div id='beacon_{$aBanner['bannerid']}' style='position: absolute; left: 0px; top: 0px; visibility: hidden;'>";
        $style = " style='width: 0px; height: 0px;'";
        $divEnd = '</div>';
    }
    $url = _getDeliveryUrl($conf['file']['log']);
    $beacon = "$div<img src='$url?bannerid={$aBanner['ad_id']}&amp;campaignid={$aBanner['placement_id']}&amp;zoneid={$zoneId}&amp;source={$source}&amp;loc={$loc}&amp;referer={$referer}&amp;block={$aBanner['block']}&amp;capping={$aBanner['capping']}&amp;session_capping={$aBanner['session_capping']}&amp;cb={random}' width='0' height='0' alt=''{$style}>{$divEnd}";
    return $beacon;
}

function _buildCompanionContext($aBanner, $context) {
    if (count($aBanner['zone_companion']) > 0) {
        // This zone call has companion banners linked to it.
        // So pass into the next call that we would like a banner from this campaign, and not from the other companion linked campaigns;
        foreach ($aBanner['zone_companion'] AS $companionCampaign) {
            $key = ($aBanner['placement_id'] == $companionCampaign) ? '==' : '!=';
            $context[] = array($key => "companionid:$companionCampaign");
        }
    }
    return $context;
}

function MAX_buildJavascriptVariablesScript($trackerid, $conversionInfo)
{
    require_once 'db_proc.php';
    $conf = $GLOBALS['_MAX']['CONF'];
    $buffer = '';
    $url = _getDeliveryUrl($conf['file']['conversionvars']);
    $tracker = MAX_getCachedEntity('tracker', $trackerid);
    $variables = MAX_getCachedEntities('variable', array('tracker_id' => $trackerid));
    $variableQuerystring = '';
    if (!empty($variables)) {
        foreach($variables as $key => $variable) {
            $variableQuerystring .= "&{$variable['name']}=\"+{$variable['name']}+\"";
            $buffer .= "
	if (!{$variable['name']}) var {$variable['name']} = 'undefined';";
        }
        if (!empty($variableQuerystring)) {
            $buffer .= "
	document.write (\"<\" + \"script language='JavaScript' type='text/javascript' src='\");
	document.write (\"$url?trackerid=$trackerid&server_raw_tracker_impression_id={$conversionInfo['server_raw_tracker_impression_id']}&server_raw_ip={$conversionInfo['server_raw_ip']}{$variableQuerystring}'\");";
            $buffer .= "\n\tdocument.write (\"></scr\"+\"ipt>\");";
            if(!empty($tracker['appendcode'])) {
                $buffer .= "\n\t" . MAX_HtmlToJavaScript($tracker['appendcode']) . "\n";
            }
        }
    }
    if (empty($buffer)) {
        $buffer = "document.write(\"\");";
    }
    return $buffer;
}

/**
 * A function that can be used to get the delivery URL,
 * or the delivery URL prefix (sans-file) if no filname
 * is passed in.
 *
 * @param string $file Optional delivery file name.
 * @return string The delivery URL.
 */
function _getDeliveryUrl($file = null)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort']) {
        $url = constructSecureDeliveryUrl($file);
    } else {
        $url = constructDeliveryURL($file);
    }
    return $url;
}

function _getImageUrlPrefix()
{
    $conf = $GLOBALS['_MAX']['CONF'];
    return ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort']) ? 'https://' . $conf['webpath']['imagesSSL']: 'http://' . $conf['webpath']['images'];
}

function MAX_HtmlToJavaScript($html)
{
    $jsLines = array();
    $search[] = "\r"; $replace[] = '';
    $search[] = '"'; $replace[] = '\"';
    $search[] = "'";  $replace[] = "\\'";
    $search[] = '<';  $replace[] = '<"+"';
    $lines = explode("\n", $html);
    foreach ($lines AS $line) {
        if(trim($line) != '') {
            $jsLines[] = 'document.write("' . trim(str_replace($search, $replace, $line)) . '\n");';
        }
    }
    return implode("\n", $jsLines);
}

?>
